package speiger.src.builder.misc;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class RegexMatcher
{
	Matcher match;
	StringWrapper text;
	
	public RegexMatcher(Pattern pattern, String text)
	{
		this.text = new StringWrapper(text);
		match = pattern.matcher(this.text);
	}
	
	public boolean find()
	{
		return match.find();
	}
	
	public int end()
	{
		return match.end()+text.getOffset();
	}
	
	public RegexMatcher appendReplacement(StringBuffer sb, String replacement)
	{
		match.appendReplacement(sb, replacement);
		return this;
	}
	
	public RegexMatcher appendTail(StringBuffer sb)
	{
		match.appendTail(sb);
		return this;
	}
	
	public RegexMatcher skip(int amount)
	{
		text.offset(amount+match.end());
		match.reset();
		return this;
	}
	
	public static class StringWrapper implements CharSequence
	{
		String s;
		int offset;
		
		public StringWrapper(String s)
		{
			this.s = s;
		}
		
		@Override
		public int length()
		{
			return s.length() - offset;
		}
		
		@Override
		public char charAt(int index)
		{
			return s.charAt(index+offset);
		}
		
		@Override
		public CharSequence subSequence(int start, int end)
		{
			return s.subSequence(start+offset, end+offset);
		}
		
		public void offset(int offset)
		{
			this.offset += offset;
		}
		
		public int getOffset()
		{
			return offset;
		}
	}
}
